//NINA_Generator_503d.js
//Eine Erweiterung des Scripts "NINA.jsx" von Olav Martin Kvern
// 31.03.12 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Zeichnet eine Menge geometrischer Objekte

//For more on NINA, see http://www.washington.edu/bibsys/mattf/nina/index.html

// die Strichlnge definieren
var curD =  23;
// die Arrays mit den Zentren der NINAs definieren
// A4 Querformat
var offPos0 = new Array ([52.5, 49.5], [52.5, 148.5], [52.5, 247.5], [157.5, 49.5], [157.5, 148.5], [157.5, 247.5]);
// A4 Hochformat
var offPos1 = new Array ([51.5, 54.5], [51.5, 155.5], [148.5, 54.5], [148.5, 155.5], [245.5, 54.5], [245.5, 155.5]);
// die Version speichern
var appVers = (app.version[0])*1;

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs  = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var nPts    = prefVal[0]*1;
	var aPlsS   = prefVal[1]*1;
	var aPlsE   = prefVal[2]*1;
	var bPls    = prefVal[3]*1;
	var orDoc   = prefVal[4]*1;
	var rb1     = 1;
	var rb2     = 0;
	if (orDoc  == 1) {
		rb1       = 0;
		rb2       = 1;
	}
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	var nPts  = 201;
	var aPlsS =   1;
	var aPlsE =  16;
	var bPls  = 161;
	var rb1   = 1;
	var rb2   = 0;
}

// die Funktion aufrufen, welche den Dialog zeigt und auswertet
var anArray = displayDialog(nPts, aPlsS, aPlsE, bPls, rb1, rb2);
var numOfLines  = anArray[0];
var aPulseStart = anArray[1];
var aPulseEnd   = anArray[2];
var bPulse      = anArray[3];
var orDoc       = anArray[4];

// die Werte prfen
if (aPulseStart > aPulseEnd) {
	var tmpPulse    = aPulseStart;
	var aPulseStart = aPulseEnd;
	var aPulseEnd   = tmpPulse;
}
if (aPulseEnd > bPulse) {
	var tmpPulse  = aPulseEnd;
	var aPulseEnd = bPulse;
	var bPulse    = tmpPulse;
}

// ein Dokument erzeugen
curDoc = app.documents.add();
curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.verticalMeasurementUnits   = MeasurementUnits.millimeters;
if (orDoc == 0) {
	curDoc.documentPreferences.properties = {pageWidth:297, pageHeight:210, facingPages:false, masterTextFrame:false};
}
else {
	curDoc.documentPreferences.properties = {pageWidth:210, pageHeight:297, facingPages:false, masterTextFrame:false};
}
curDoc.masterSpreads[0].pages[0].marginPreferences.properties = {top:0, left:0, bottom:0, right:0, columnCount:1};

// die Anzahl NINAs speichern
var nNinas = (aPulseEnd - aPulseStart) + 1;
// die bentigte Anzahl Seiten ausrechnen und einfgen
var nPages = Math.ceil(nNinas/6);
for (var p=1; p<nPages; p++) {
	curDoc.pages.add();
}

// das Auffrischen abstellen
app.scriptPreferences.enableRedraw = false;

var pCtr = aPulseStart;
// eine Schleife durch die Seiten
for (var p=0; p<nPages; p++) {
	// eine Schleife durch die 6 Objekte pro Seite
	for (var n=0; n<6; n++) {
		if (orDoc == 0) {
			var yPos = offPos0[n][0];
			var xPos = offPos0[n][1];
		}
		else {
			var yPos = offPos1[n][0];
			var xPos = offPos1[n][1];
		}
		// die Funktion aufrufen, welche die aktuelle NINA zeichnet
		drawNINA(p, xPos, yPos, curD, numOfLines, pCtr, bPulse);
		pCtr++;
		if (pCtr > aPulseEnd) { break; }
	}
}

// das Auffrischen wieder aktivieren
app.scriptPreferences.enableRedraw = true;

if (appVers > 6) { // wenn CS5 oder hher
	// den Bildschirm-Modus auf "Prsentation" setzen
	app.activeWindow.screenMode = ScreenModeOptions.PRESENTATION_PREVIEW;
}
else {
	// den Bildschirm-Modus auf "Vorschau" setzen
	app.activeWindow.screenMode = ScreenModeOptions.PREVIEW_TO_PAGE;
}

// die erste Seite anzeigen
app.activeWindow.activePage = curDoc.pages[0];

// die Funktion, welche die Informationen vorbereitet
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/NinaGen503.txt");
	}
	else {
		var f = new File("~/Library/Preferences/NinaGen503.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// den Dialog vorbereiten und anzeigen
function displayDialog(nPts, aPlsS, aPlsE, bPls, rb1, rb2) {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var fieldWidth = 40;
	var aDialog = app.dialogs.add({name:"NINA-Generator"});
	with (aDialog.dialogColumns.add()) {
		with (borderPanels.add()) { 
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Anzahl Punkte"});
				staticTexts.add({staticLabel:"Schwingung A (Startwert)"});
				staticTexts.add({staticLabel:"Schwingung A (Endwert)"});
				staticTexts.add({staticLabel:"Schwingung B (fixer Wert)"});
			}
			with (dialogColumns.add()) {
				var nPointsField = integerEditboxes.add({editValue:nPts, minWidth:fieldWidth});
				var APulseStart  = integerEditboxes.add({editValue:aPlsS,minWidth:fieldWidth});
				var APulseEnd    = integerEditboxes.add({editValue:aPlsE,minWidth:fieldWidth});
				var BPulseField  = integerEditboxes.add({editValue:bPls, minWidth:fieldWidth});
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Ausrichtung:"});
			with(aligButtons = radiobuttonGroups.add()) {
				radiobuttonControls.add({staticLabel:"A4 Querformat", checkedState:rb1});
				radiobuttonControls.add({staticLabel:"A4 Hochformat", checkedState:rb2});
			}
		}
	}
	if(aDialog.show() == true) {
		var numOfLines  = nPointsField.editValue;
		var aPulseStart = APulseStart.editValue;
		var aPulseEnd   = APulseEnd.editValue;
		var bPulse      = BPulseField.editValue;
		var orDoc       = aligButtons.selectedButton;
		aDialog.destroy();
		var prefsList = new Array (numOfLines, aPulseStart, aPulseEnd, bPulse, orDoc);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		return [numOfLines, aPulseStart, aPulseEnd, bPulse, orDoc];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// das Ergebnis in eine Datei schreiben
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/NinaGen503.txt");
	}
	else {
		var f = File("~/Library/Preferences/NinaGen503.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// diese Funktion zeichnet die aktuelle NINA
function drawNINA(p, xPos, yPos, curDiameter, numOfLines, aPulse, bPulse) {
	var cur_x, cur_y;
	var aAnchor = new Array(2);
	var arr = new Array(numOfLines);
	// den Array "arr" mit einer Reihe von Koordinaten fllen
	for (var ctr = 0; ctr < numOfLines; ctr++) {
		cur_x = ((Math.cos((-2 * Math.PI * aPulse * ctr) / numOfLines) + Math.cos((-2 * Math.PI * bPulse * ctr) / numOfLines)) * curDiameter) + xPos;
		cur_y = ((Math.sin((-2 * Math.PI * aPulse * ctr) / numOfLines) + Math.sin((-2 * Math.PI * bPulse * ctr) / numOfLines)) * curDiameter) + yPos;
		aAnchor = [cur_x, cur_y];
		arr[ctr] = aAnchor;
	}
	with (curDoc){
		var curPage = curDoc.pages[p];
		with (curPage) {
			var newLine = graphicLines.add();
			newLine.strokeWeight = "0.5pt";
			var curPath = newLine.paths.item(0);
			curPath.entirePath = arr;
			curPath.pathType = PathType.closedPath;
			// die Farben zuweisen
			newLine.properties = {fillColor:"None", strokeColor:"Black", strokeTint:-1, strokeAlignment:1936998723};
			// die NINA-Einstellungen in das Objekt-Label setzen
			newLine.label = "Linienlnge: " + curDiameter + " mm\rAnzahl Punkte: " + numOfLines + "\rSchwingung A: " + aPulse + "\rSchwingung B: " + bPulse;
		}
	}
}